


 25-akpm/arch/arm/kernel/time.c |   16 ++++++++++------
 1 files changed, 10 insertions(+), 6 deletions(-)

diff -puN arch/arm/kernel/time.c~arm-do_settimeofday-update arch/arm/kernel/time.c
--- 25/arch/arm/kernel/time.c~arm-do_settimeofday-update	Wed Jun 11 15:12:46 2003
+++ 25-akpm/arch/arm/kernel/time.c	Wed Jun 11 15:14:08 2003
@@ -172,8 +172,11 @@ void do_gettimeofday(struct timeval *tv)
 	tv->tv_usec = usec;
 }
 
-void do_settimeofday(struct timeval *tv)
+int do_settimeofday(struct timespec *tv)
 {
+	if ((unsigned long)tv->tv_nsec >= NSEC_PER_SEC)
+		return -EINVAL;
+
 	write_seqlock_irq(&xtime_lock);
 	/*
 	 * This is revolting. We need to set "xtime" correctly. However, the
@@ -181,21 +184,22 @@ void do_settimeofday(struct timeval *tv)
 	 * wall time.  Discover what correction gettimeofday() would have
 	 * done, and then undo it!
 	 */
-	tv->tv_usec -= gettimeoffset();
-	tv->tv_usec -= (jiffies - wall_jiffies) * USECS_PER_JIFFY;
+	tv->tv_nsec -= 1000 * (gettimeoffset() +
+				(jiffies - wall_jiffies) * USECS_PER_JIFFY);
 
-	while (tv->tv_usec < 0) {
-		tv->tv_usec += 1000000;
+	while (tv->tv_nsec < 0) {
+		tv->tv_nsec += NSEC_PER_SEC;
 		tv->tv_sec--;
 	}
 
 	xtime.tv_sec = tv->tv_sec;
-	xtime.tv_nsec = tv->tv_usec * 1000;
+	xtime.tv_nsec = tv->tv_nsec;
 	time_adjust = 0;		/* stop active adjtime() */
 	time_status |= STA_UNSYNC;
 	time_maxerror = NTP_PHASE_LIMIT;
 	time_esterror = NTP_PHASE_LIMIT;
 	write_sequnlock_irq(&xtime_lock);
+	return 0;
 }
 
 static struct irqaction timer_irq = {

_
